#!/usr/bin/env python

import sys
import errno


import sys
import time
import os
from python_sdk_api.sxd_api import *


print "[+] MCIA register access test start"
print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

mcia = ku_mcia_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET

mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0
mcia.size = 28


print "[+] Get MCIA content, set Normal operation"
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = 0x0F9A0000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x17 dword0 : 0x%08x" % mcia.dword_0)
mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
mcia.dword_0 = 0xC0000000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x15 dword0 : 0x%08x" % mcia.dword_0)

print "[+] Get MCIA"
meta.access_cmd = SXD_ACCESS_CMD_GET
mcia.device_address = 0
mcia.size = 28
sxd_access_reg_mcia(mcia, meta, 1, None, None)

print "[+] Module: ", mcia.module

print "[+] Get MCIA content"
print "===================="
print ("[+] dword0 : 0x%08x" % mcia.dword_0)
print ("[+] dword1 : 0x%08x" % mcia.dword_1)
print ("[+] dword2 : 0x%08x" % mcia.dword_2)
print ("[+] dword3 : 0x%08x" % mcia.dword_3)
print ("[+] dword4 : 0x%08x" % mcia.dword_4)
print ("[+] dword5 : 0x%08x" % mcia.dword_5)
print ("[+] dword6 : 0x%08x" % mcia.dword_6)
print ("[+] dword7 : 0x%08x" % mcia.dword_7)
print ("[+] dword8 : 0x%08x" % mcia.dword_8)
print ("[+] dword9 : 0x%08x" % mcia.dword_9)
print ("[+] dword10: 0x%08x" % mcia.dword_10)
print ("[+] dword11: 0x%08x" % mcia.dword_11)

print "[+] Get MCIA content, set BroadR-Reach LRE Registers"
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = 0x0F9A0000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x17 dword0 : 0x%08x" % mcia.dword_0)

mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
mcia.dword_0 = 0x80000000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x15 dword0 : 0x%08x" % mcia.dword_0)

print "[+] Get MCIA"
mcia.device_address = 0
mcia.size = 10
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

print "[+] Get MCIA content"
print "===================="
print ("[+] dword0 : 0x%08x" % mcia.dword_0)
print ("[+] dword1 : 0x%08x" % mcia.dword_1)
print ("[+] dword2 : 0x%08x" % mcia.dword_2)


######################################################
print "[+] Get MCIA content, read VLAN Tag1 reg "
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = 0x0D150000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

mcia.dword_0 = 0
mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x15 dword0 : 0x%08x" % mcia.dword_0)

print "[+] Get MCIA content, read VLAN Tag2 reg "
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = 0x0D160000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x15 dword0 : 0x%08x" % mcia.dword_0)
