#!/usr/bin/env python

import sys
import errno


import sys
import time
import os
from python_sdk_api.sxd_api import *


print "[+] MCIA register access test start"
print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

mcia = ku_mcia_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0


######################################################
# read extention registers
print "===================="
print "[+] Extension Registers:"

EXT_REG = 0x0F900000
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = EXT_REG
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x17 dword0 : 0x%08x" % mcia.dword_0)

mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] ext_reg:0x%x , dword0: 0x%04x" % ((EXT_REG >> 16) & 0xff, mcia.dword_0 >> 16))


EXT_REG = 0x0F990000
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = EXT_REG
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x17 dword0 : 0x%08x" % mcia.dword_0)

mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] ext_reg:0x%x , dword0: 0x%04x" % ((EXT_REG >> 16) & 0xff, mcia.dword_0 >> 16))


EXT_REG = 0x0F9A0000
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = EXT_REG
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x17 dword0 : 0x%08x" % mcia.dword_0)

mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] ext_reg:0x%x , dword0: 0x%04x" % ((EXT_REG >> 16) & 0xff, mcia.dword_0 >> 16))

######################################################
print "===================="
print "[+] BroadR-Reach LRE Registers:"
mcia.module = 8
mcia.i2c_device_address = 0x56
mcia.page_number = 0
mcia.device_address = 0x17
mcia.size = 2
mcia.dword_0 = 0x0F9A0000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x17 dword0 : 0x%08x" % mcia.dword_0)

mcia.page_number = 0
mcia.device_address = 0x15
mcia.size = 2
mcia.dword_0 = 0x80000000
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr 0x15 dword0 : 0x%08x" % mcia.dword_0)

mcia.device_address = 0
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr:%d , dword0 : 0x%04x" % (mcia.device_address, mcia.dword_0 >> 16))

mcia.device_address = 1
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr:%d , dword0 : 0x%04x" % (mcia.device_address, mcia.dword_0 >> 16))

mcia.device_address = 2
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr:%d , dword0 : 0x%04x" % (mcia.device_address, mcia.dword_0 >> 16))

mcia.device_address = 3
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr:%d , dword0 : 0x%04x" % (mcia.device_address, mcia.dword_0 >> 16))

mcia.device_address = 4
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr:%d , dword0 : 0x%04x" % (mcia.device_address, mcia.dword_0 >> 16))

mcia.device_address = 15
mcia.size = 2
meta.access_cmd = SXD_ACCESS_CMD_GET
sxd_access_reg_mcia(mcia, meta, 1, None, None)
print ("[+] addr:%d, dword0 : 0x%04x" % (mcia.device_address, mcia.dword_0 >> 16))
print "===================="
